
<!doctype html PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><title>Python: module main</title>
</head><body bgcolor="#f0f0f8">

<table width="100%" cellspacing=0 cellpadding=2 border=0 summary="heading">
<tr bgcolor="#7799ee">
<td valign=bottom>&nbsp;<br>
<font color="#ffffff" face="helvetica, arial">&nbsp;<br><big><big><strong>main</strong></big></big></font></td
><td align=right valign=bottom
><font color="#ffffff" face="helvetica, arial"><a href=".">index</a><br><a href="file:./main.py">./main.py</a></font></td></tr></table>
    <p><tt>Efficient&nbsp;Hash&nbsp;Table&nbsp;Simulation<br>
&nbsp;<br>
Main&nbsp;file&nbsp;of&nbsp;the&nbsp;EHT&nbsp;simulation&nbsp;framework.<br>
Unifies&nbsp;all&nbsp;classes&nbsp;and&nbsp;provides&nbsp;argument&nbsp;checking.<br>
&nbsp;<br>
The&nbsp;simulator&nbsp;framework&nbsp;consists&nbsp;of&nbsp;the&nbsp;following&nbsp;modules:<br>
&nbsp;<br>
abstract&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;--&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;implements&nbsp;abstract&nbsp;bases&nbsp;classes&nbsp;and&nbsp;methods<br>
math2&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;--&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;additional&nbsp;math&nbsp;functions<br>
bloom&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;--&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Bloom&nbsp;filters&nbsp;and&nbsp;derivates<br>
compress&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;--&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;compression&nbsp;interface&nbsp;and&nbsp;classes<br>
hash&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;--&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;hash&nbsp;functions&nbsp;and&nbsp;factories<br>
eht&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;--&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;efficient&nbsp;hash&nbsp;table&nbsp;implementation<br>
simulator&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;--&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;configurator&nbsp;and&nbsp;simulator&nbsp;classes&nbsp;for&nbsp;EHT&nbsp;simulation<br>
&nbsp;<br>
See&nbsp;individual&nbsp;documentations&nbsp;of&nbsp;the&nbsp;modules&nbsp;for&nbsp;more&nbsp;information.<br>
&nbsp;<br>
Output&nbsp;is&nbsp;generated&nbsp;both&nbsp;on&nbsp;stdout&nbsp;and&nbsp;stderr.<br>
stdout&nbsp;yields&nbsp;the&nbsp;results&nbsp;which&nbsp;can&nbsp;directly&nbsp;be&nbsp;written&nbsp;to&nbsp;a&nbsp;csv&nbsp;file.<br>
stderr&nbsp;shows&nbsp;runtime&nbsp;and&nbsp;error&nbsp;information&nbsp;which&nbsp;can&nbsp;be&nbsp;diverted&nbsp;to&nbsp;/dev/null<br>
&nbsp;<br>
&nbsp;<br>
Requirements<br>
------------<br>
The&nbsp;framework&nbsp;is&nbsp;built&nbsp;on&nbsp;python&nbsp;2.5&nbsp;/&nbsp;2.6.&nbsp;It&nbsp;does&nbsp;NOT&nbsp;run<br>
on&nbsp;python&nbsp;3.0&nbsp;or&nbsp;higher&nbsp;due&nbsp;to&nbsp;substantial&nbsp;changes&nbsp;in&nbsp;some&nbsp;function<br>
definitions.<br>
&nbsp;<br>
Usage<br>
-----<br>
python&nbsp;main.py&nbsp;[options]<br>
&nbsp;<br>
Command&nbsp;line&nbsp;Options<br>
--------------------<br>
-n<br>
&nbsp;&nbsp;&nbsp;&nbsp;Sets&nbsp;the&nbsp;number&nbsp;of&nbsp;items&nbsp;to&nbsp;insert&nbsp;into&nbsp;the&nbsp;EHT.<br>
&nbsp;&nbsp;&nbsp;&nbsp;The&nbsp;EHT&nbsp;is&nbsp;built&nbsp;accordingly&nbsp;to&nbsp;n.<br>
&nbsp;<br>
-c<br>
&nbsp;&nbsp;&nbsp;&nbsp;The&nbsp;table&nbsp;size&nbsp;constant.&nbsp;The&nbsp;size&nbsp;of&nbsp;an&nbsp;FHT&nbsp;and&nbsp;EHT<br>
&nbsp;&nbsp;&nbsp;&nbsp;is&nbsp;calculated&nbsp;using&nbsp;the&nbsp;equation:<br>
&nbsp;&nbsp;&nbsp;&nbsp;m&nbsp;=&nbsp;2&nbsp;**&nbsp;(log(c*n,2))<br>
&nbsp;&nbsp;&nbsp;&nbsp;c&nbsp;thus&nbsp;gives&nbsp;the&nbsp;number&nbsp;of&nbsp;counters/buckets&nbsp;per&nbsp;item.<br>
&nbsp;&nbsp;&nbsp;&nbsp;Default:&nbsp;1.6<br>
&nbsp;<br>
-k<br>
&nbsp;&nbsp;&nbsp;&nbsp;The&nbsp;number&nbsp;of&nbsp;hash&nbsp;functions&nbsp;to&nbsp;use.&nbsp;Defaults&nbsp;to&nbsp;0<br>
&nbsp;&nbsp;&nbsp;&nbsp;in&nbsp;which&nbsp;case&nbsp;the&nbsp;optimal&nbsp;number&nbsp;is&nbsp;calculated&nbsp;by<br>
&nbsp;&nbsp;&nbsp;&nbsp;k&nbsp;=&nbsp;m/n&nbsp;*&nbsp;log(2)<br>
&nbsp;<br>
-w<br>
&nbsp;&nbsp;&nbsp;&nbsp;Specify&nbsp;the&nbsp;maximum&nbsp;bucket&nbsp;load&nbsp;/&nbsp;width&nbsp;for&nbsp;online<br>
&nbsp;&nbsp;&nbsp;&nbsp;table&nbsp;buckets.&nbsp;Default:&nbsp;4<br>
&nbsp;<br>
-s<br>
&nbsp;&nbsp;&nbsp;&nbsp;Sram&nbsp;word&nbsp;size&nbsp;in&nbsp;bits.&nbsp;Default:&nbsp;128<br>
&nbsp;&nbsp;&nbsp;&nbsp;Primarily&nbsp;influences&nbsp;the&nbsp;compression&nbsp;quality<br>
&nbsp;<br>
-l<br>
&nbsp;&nbsp;&nbsp;&nbsp;Use&nbsp;linear&nbsp;table&nbsp;growth&nbsp;instead&nbsp;of&nbsp;multiples&nbsp;of&nbsp;two.<br>
&nbsp;&nbsp;&nbsp;&nbsp;That&nbsp;is&nbsp;calculate&nbsp;size&nbsp;m&nbsp;using&nbsp;equation:<br>
&nbsp;&nbsp;&nbsp;&nbsp;m&nbsp;=&nbsp;c&nbsp;*&nbsp;n<br>
&nbsp;&nbsp;&nbsp;&nbsp;If&nbsp;-l&nbsp;is&nbsp;set,&nbsp;universal&nbsp;hash&nbsp;functions&nbsp;can't&nbsp;be<br>
&nbsp;&nbsp;&nbsp;&nbsp;used,&nbsp;since&nbsp;they&nbsp;always&nbsp;produce&nbsp;multiples&nbsp;of&nbsp;two.<br>
&nbsp;&nbsp;&nbsp;&nbsp;Instead&nbsp;k&nbsp;general&nbsp;purpose&nbsp;hash&nbsp;functions&nbsp;are<br>
&nbsp;&nbsp;&nbsp;&nbsp;randomly&nbsp;selected&nbsp;and&nbsp;a&nbsp;HashFactory&nbsp;built.<br>
&nbsp;<br>
-r<br>
&nbsp;&nbsp;&nbsp;&nbsp;Set&nbsp;the&nbsp;desired&nbsp;compression&nbsp;rate,&nbsp;number&nbsp;of&nbsp;counters<br>
&nbsp;&nbsp;&nbsp;&nbsp;compressed&nbsp;in&nbsp;one&nbsp;sram&nbsp;memory&nbsp;word.&nbsp;Defaults&nbsp;to&nbsp;0<br>
&nbsp;&nbsp;&nbsp;&nbsp;in&nbsp;which&nbsp;case&nbsp;the&nbsp;optimum&nbsp;is&nbsp;computed&nbsp;during&nbsp;pruning.<br>
&nbsp;<br>
-f<br>
&nbsp;&nbsp;&nbsp;&nbsp;Set&nbsp;a&nbsp;replacement&nbsp;factor&nbsp;0&nbsp;&lt;&nbsp;f&nbsp;&lt;=&nbsp;1&nbsp;which&nbsp;is&nbsp;the&nbsp;number<br>
&nbsp;&nbsp;&nbsp;&nbsp;of&nbsp;items&nbsp;in&nbsp;the&nbsp;table&nbsp;which&nbsp;get&nbsp;replaced&nbsp;after&nbsp;pruning.<br>
&nbsp;&nbsp;&nbsp;&nbsp;This&nbsp;is&nbsp;to&nbsp;test&nbsp;update&nbsp;performance.<br>
&nbsp;<br>
-t<br>
&nbsp;&nbsp;&nbsp;&nbsp;set&nbsp;the&nbsp;number&nbsp;of&nbsp;tries,&nbsp;simulation&nbsp;runs.&nbsp;Default:&nbsp;10<br>
&nbsp;<br>
Examples<br>
--------<br>
&gt;&nbsp;python&nbsp;main.py&nbsp;-n&nbsp;10000<br>
&nbsp;<br>
&nbsp;&nbsp;&nbsp;&nbsp;build&nbsp;an&nbsp;EHT&nbsp;for&nbsp;10.000&nbsp;items&nbsp;with&nbsp;default&nbsp;other&nbsp;parameters<br>
&nbsp;<br>
&gt;&nbsp;python&nbsp;main.py&nbsp;-n&nbsp;100000&nbsp;-c&nbsp;3.2&nbsp;-w&nbsp;2&nbsp;-s&nbsp;64<br>
&nbsp;<br>
&nbsp;&nbsp;&nbsp;&nbsp;build&nbsp;an&nbsp;EHT&nbsp;for&nbsp;100.000&nbsp;items,&nbsp;3.2&nbsp;counters&nbsp;per&nbsp;item&nbsp;a&nbsp;maxload&nbsp;of&nbsp;2<br>
&nbsp;&nbsp;&nbsp;&nbsp;entries&nbsp;per&nbsp;online&nbsp;bucket&nbsp;and&nbsp;an&nbsp;sram&nbsp;word&nbsp;size&nbsp;of&nbsp;64&nbsp;bits.<br>
&nbsp;<br>
&gt;&nbsp;python&nbsp;main.py&nbsp;-n&nbsp;1000000&nbsp;-c&nbsp;1.6&nbsp;-w&nbsp;3&nbsp;-s&nbsp;64&nbsp;-l&nbsp;&gt;&gt;&nbsp;result.csv&nbsp;2&gt;&nbsp;/dev/null<br>
&nbsp;<br>
&nbsp;&nbsp;&nbsp;&nbsp;build&nbsp;an&nbsp;EHT&nbsp;for&nbsp;1&nbsp;million&nbsp;items&nbsp;with&nbsp;1.6&nbsp;buckets&nbsp;per&nbsp;item&nbsp;and&nbsp;linear&nbsp;function<br>
&nbsp;&nbsp;&nbsp;&nbsp;for&nbsp;m.&nbsp;Sram&nbsp;word&nbsp;size&nbsp;is&nbsp;64&nbsp;bits.&nbsp;Print&nbsp;results&nbsp;to&nbsp;the&nbsp;file&nbsp;result.csv&nbsp;and<br>
&nbsp;&nbsp;&nbsp;&nbsp;divert&nbsp;error&nbsp;output&nbsp;to&nbsp;/dev/null.</tt></p>
<p>
<table width="100%" cellspacing=0 cellpadding=2 border=0 summary="section">
<tr bgcolor="#aa55cc">
<td colspan=3 valign=bottom>&nbsp;<br>
<font color="#ffffff" face="helvetica, arial"><big><strong>Modules</strong></big></font></td></tr>
    
<tr><td bgcolor="#aa55cc"><tt>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</tt></td><td>&nbsp;</td>
<td width="100%"><table width="100%" summary="list"><tr><td width="25%" valign=top><a href="abstract.html">abstract</a><br>
<a href="bloom.html">bloom</a><br>
<a href="compress.html">compress</a><br>
</td><td width="25%" valign=top><a href="eht.html">eht</a><br>
<a href="getopt.html">getopt</a><br>
<a href="xhash.html">xhash</a><br>
</td><td width="25%" valign=top><a href="math2.html">math2</a><br>
<a href="simulator.html">simulator</a><br>
<a href="sys.html">sys</a><br>
</td><td width="25%" valign=top><a href="time.html">time</a><br>
</td></tr></table></td></tr></table><p>
<table width="100%" cellspacing=0 cellpadding=2 border=0 summary="section">
<tr bgcolor="#eeaa77">
<td colspan=3 valign=bottom>&nbsp;<br>
<font color="#ffffff" face="helvetica, arial"><big><strong>Functions</strong></big></font></td></tr>
    
<tr><td bgcolor="#eeaa77"><tt>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</tt></td><td>&nbsp;</td>
<td width="100%"><dl><dt><a name="-checkargv"><strong>checkargv</strong></a>(argv)</dt><dd><tt><a href="#-checkargv">checkargv</a>()&nbsp;-&gt;&nbsp;Configurator,int,float<br>
&nbsp;<br>
Checks&nbsp;all&nbsp;command&nbsp;line&nbsp;arguments,&nbsp;builds&nbsp;and<br>
returns&nbsp;a&nbsp;Configurator&nbsp;for&nbsp;the&nbsp;Simulator&nbsp;and&nbsp;the&nbsp;number<br>
of&nbsp;tries&nbsp;and&nbsp;a&nbsp;replacement&nbsp;factor</tt></dd></dl>
 <dl><dt><a name="-usage"><strong>usage</strong></a>()</dt><dd><tt><a href="#-usage">usage</a>()&nbsp;--&nbsp;print&nbsp;help&nbsp;screen</tt></dd></dl>
</td></tr></table><p>
<table width="100%" cellspacing=0 cellpadding=2 border=0 summary="section">
<tr bgcolor="#55aa55">
<td colspan=3 valign=bottom>&nbsp;<br>
<font color="#ffffff" face="helvetica, arial"><big><strong>Data</strong></big></font></td></tr>
    
<tr><td bgcolor="#55aa55"><tt>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</tt></td><td>&nbsp;</td>
<td width="100%"><strong>__all__</strong> = ['checkargv', 'usage']</td></tr></table>
</body></html>